package org.codehaus.mojo.rmic;

/*
 * Copyright (c) 2004, Codehaus.org
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is furnished to do
 * so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

import java.util.Map;

/**
 * @author <a href="mailto:trygvis@inamo.no">Trygve Laugst&oslash;l</a>
 * @version $Id: DefaultRmiCompilerManager.java 7953 2008-10-21 17:12:38Z pgier $
 */
public class DefaultRmiCompilerManager implements RmiCompilerManager
{
    /**
     * @plexus.requirement role=RmiCompiler
     */
    private Map rmiCompilers;

    /**
     * Default compiler factory.
     * 
     * @param id The ID of the compiler.  The valid IDs are located in the components.xml file.
     * @throws NoSuchRmiCompilerException If the compiler is not found
     * @return The compiler object
     */
    public RmiCompiler getRmiCompiler( String id )
        throws NoSuchRmiCompilerException
    {
        RmiCompiler rmiCompiler = (RmiCompiler) rmiCompilers.get( id );

        if ( rmiCompiler == null )
        {
            throw new NoSuchRmiCompilerException( id );
        }

        return rmiCompiler;
    }
}
