package org.codehaus.mojo.rmic;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on rmic-maven-plugin.<br/> Call <pre>  mvn rmic:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Mon Jun 28 14:43:53 CDT 2010
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.5.1)
 * @goal help
 * @requiresProject false
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "org.codehaus.mojo:rmic-maven-plugin:1.1", 0 );
        append( sb, "", 0 );

        append( sb, "RMI Compiler Maven Plugin", 0 );
        append( sb, "RMI Compiler Maven Plugin", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 4 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "rmic:help", 0 );
            append( sb, "Display help information on rmic-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0rmic:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "package".equals( goal ) )
        {
            append( sb, "rmic:package", 0 );
            append( sb, "Creates a jar containing the rmic generated classes.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classifier (Default: client)", 2 );
                append( sb, "Classifier to append to the jar.", 3 );
                append( sb, "", 0 );

                append( sb, "excludes", 2 );
                append( sb, "The file patterns to exclude from the jar.", 3 );
                append( sb, "", 0 );

                append( sb, "finalName (Default: ${project.build.finalName})", 2 );
                append( sb, "The base name of the generated jar. This name does not include the classifier or the extension.", 3 );
                append( sb, "", 0 );

                append( sb, "includes", 2 );
                append( sb, "The file patterns to include in the jar. By default, all classes ending with _Stub.class will be included.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.directory}/rmi-classes)", 2 );
                append( sb, "This directory contains the output of rmic (where the Stub classes are located). This is not the directory where the jar file will be written.", 3 );
                append( sb, "", 0 );

                append( sb, "target (Default: ${project.build.directory})", 2 );
                append( sb, "The directory to which the generated jar should be written.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "rmic".equals( goal ) )
        {
            append( sb, "rmic:rmic", 0 );
            append( sb, "Compiles rmi stubs and skeleton classes from a remote implementation class.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classesDirectory (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Directory tree where the compiled Remote classes are located.", 3 );
                append( sb, "", 0 );

                append( sb, "compilerId (Default: sun)", 2 );
                append( sb, "The id of the rmi compiler to use.", 3 );
                append( sb, "", 0 );

                append( sb, "excludes", 2 );
                append( sb, "A list of exclusions when searching for classes to compile.", 3 );
                append( sb, "", 0 );

                append( sb, "idl (Default: false)", 2 );
                append( sb, "Create IDL.", 3 );
                append( sb, "", 0 );

                append( sb, "iiop (Default: false)", 2 );
                append( sb, "Create stubs for IIOP.", 3 );
                append( sb, "", 0 );

                append( sb, "includes", 2 );
                append( sb, "A list of inclusions when searching for classes to compile.", 3 );
                append( sb, "", 0 );

                append( sb, "keep (Default: false)", 2 );
                append( sb, "Do not delete intermediate generated source files.", 3 );
                append( sb, "", 0 );

                append( sb, "noLocalStubs", 2 );
                append( sb, "Do not create stubs optimized for same process.", 3 );
                append( sb, "", 0 );

                append( sb, "noValueMethods", 2 );
                append( sb, "Do not generate methods for valuetypes.", 3 );
                append( sb, "", 0 );

                append( sb, "nowarn", 2 );
                append( sb, "Turn off rmic warnings.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.directory}/rmi-classes)", 2 );
                append( sb, "Specifies where to place rmic generated class files. If the generated files need to be included in the main project artifact, this parameter can be set to ${project.build.outputDirectory}.", 3 );
                append( sb, "", 0 );

                append( sb, "staleMillis (Default: 0)", 2 );
                append( sb, "Time in milliseconds between automatic recompilations. A value of 0 means that up to date rmic output classes will not be recompiled until the source classes change.", 3 );
                append( sb, "", 0 );

                append( sb, "verbose", 2 );
                append( sb, "Enable verbose rmic output.", 3 );
                append( sb, "", 0 );

                append( sb, "version", 2 );
                append( sb, "The version of the rmi protocol to which the stubs should be compiled. Valid values include 1.1, 1.2, compat. See the rmic documentation for more information. If nothing is specified the underlying rmi compiler will choose the default value. For example, in sun jdk 1.5 the default is 1.2.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "test-rmic".equals( goal ) )
        {
            append( sb, "rmic:test-rmic", 0 );
            append( sb, "Compiles rmi stubs and skeleton classes from a remote implementation class. By default runs against files in the test-classes directory.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "compilerId (Default: sun)", 2 );
                append( sb, "The id of the rmi compiler to use.", 3 );
                append( sb, "", 0 );

                append( sb, "excludes", 2 );
                append( sb, "A list of exclusions when searching for classes to compile.", 3 );
                append( sb, "", 0 );

                append( sb, "idl (Default: false)", 2 );
                append( sb, "Create IDL.", 3 );
                append( sb, "", 0 );

                append( sb, "iiop (Default: false)", 2 );
                append( sb, "Create stubs for IIOP.", 3 );
                append( sb, "", 0 );

                append( sb, "includes", 2 );
                append( sb, "A list of inclusions when searching for classes to compile.", 3 );
                append( sb, "", 0 );

                append( sb, "keep (Default: false)", 2 );
                append( sb, "Do not delete intermediate generated source files.", 3 );
                append( sb, "", 0 );

                append( sb, "noLocalStubs", 2 );
                append( sb, "Do not create stubs optimized for same process.", 3 );
                append( sb, "", 0 );

                append( sb, "noValueMethods", 2 );
                append( sb, "Do not generate methods for valuetypes.", 3 );
                append( sb, "", 0 );

                append( sb, "nowarn", 2 );
                append( sb, "Turn off rmic warnings.", 3 );
                append( sb, "", 0 );

                append( sb, "staleMillis (Default: 0)", 2 );
                append( sb, "Time in milliseconds between automatic recompilations. A value of 0 means that up to date rmic output classes will not be recompiled until the source classes change.", 3 );
                append( sb, "", 0 );

                append( sb, "testClassesDirectory (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "Directory tree where the compiled Remote classes are located.", 3 );
                append( sb, "", 0 );

                append( sb, "testOutputDirectory (Default: ${project.build.directory}/rmi-test-classes)", 2 );
                append( sb, "Specifies where to place rmic generated class files. If the generated files need to be included in the project test artifact, this parameter can be set to ${project.build.testOutputDirectory}.", 3 );
                append( sb, "", 0 );

                append( sb, "verbose", 2 );
                append( sb, "Enable verbose rmic output.", 3 );
                append( sb, "", 0 );

                append( sb, "version", 2 );
                append( sb, "The version of the rmi protocol to which the stubs should be compiled. Valid values include 1.1, 1.2, compat. See the rmic documentation for more information. If nothing is specified the underlying rmi compiler will choose the default value. For example, in sun jdk 1.5 the default is 1.2.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
